package firstApp

class Rational(n: Int, d: Int) {
  val num = n
  val den = d
  def isNull(): Boolean = (num == 0)
  def this(x: Int) = { this(x, 1) }
  def +(r: Rational): Rational = {
    new Rational(this.num * r.den + this.den * r.num, this.den * r.den)
  }
  override def toString = this.num + "/" + this.den
}

object MonApplication extends App {
  implicit def int2rat(x: Int): Rational = { new Rational(x, 1) }
  val r1 = new Rational(3, 4)
  val r2 = new Rational(2)
  println(r1 + r2)
  println(r1 + 100)
}
