/* Exercice 6 */

class Rational(n: Int, d: Int) {
  require(d != 0)
  val num = n
  val den = d
  def isNull(): Boolean = (num == 0)
  def this(x: Int) = { this(x, 1) }
  def +(r: Rational): Rational =
    new Rational(num * r.den + r.num * this.den, this.den * r.den)
  override def toString(): String =
    this.num.toString + "/" + this.den.toString()
}

val r1 = new Rational(3, 4)
val r2 = new Rational(2)
val r3 = new Rational(3, 4)

r1 + r2

implicit def int2rational(x: Int): Rational =
  new Rational(x)

/* Exercice 7 */

/* Exercice 8 */

/* Exercice 9 */

object PlusInfinity {
  override def toString = "+oo"
  def +(x: Double) = PlusInfinity
  def +(x: this.type) = PlusInfinity
}

PlusInfinity + 876
PlusInfinity + PlusInfinity

/* Exercice 10 */

implicit def int2inf(x: Int): PlusInfinity.type =
  PlusInfinity

876 + PlusInfinity
